
console.log('Redwax SignText: background started');

var csPorts = [];
//var nativePort = undefined;

function nativeMessaged(m) {

    console.log('Redwax SignText: background: message received from native: ', m);

    /*
     * Native message response is handled here. Send the message
     * to the correctly numbered content script.
     */
    window.csPorts.forEach(p => {
        if (p.sender.tab.id == m.id) {

           console.log('Redwax SignText: background: message passed from native to content: ', m);

            p.postMessage({ uuid: m.uuid, response: m.response, contentType: m.contentType });
        }
    });
}

function nativeDisconnected(p) {

            window.nativePort.onMessage.removeListener(nativeMessaged);
            window.nativePort.onDisconnect.removeListener(nativeDisconnected);

//    window.nativePort.disconnect();
    window.nativePort = undefined;

    window.csPorts.forEach(cp => {
        cp.postMessage({ error: 'error:nativeDisconnected', exception: p.error.message });
    });
    console.log('Redwax SignText: native port disconnected.');
}

function connected(p) {
    window.csPorts[p.sender.tab.id] = p;
    console.log('Redwax SignText: background: connection received from content: ', p);
    messageHandler = function(m) {

        console.log('Redwax SignText: background: message received from content: ', m);

        if (typeof window.nativePort === 'undefined') {

            console.log('Redwax SignText: background: open native port (attempt one)');

            window.nativePort = browser.runtime.connectNative('eu.redwax.Redwax.SignText');
            window.nativePort.onMessage.addListener(nativeMessaged);
            window.nativePort.onDisconnect.addListener(nativeDisconnected);
        }

        let url = p.sender.tab.url ? p.sender.tab.url : p.sender.url ? p.sender.url : "No URL";

        console.log('Redwax SignText: background: nativeport created');

        try {
            /*
             * Let's try send the message on the assumption the port is
             * open and works. On failure, try to open the port and retry.
             */

            console.log('Redwax SignText: background: send message (attempt one)');

            window.nativePort.postMessage({ url: url, id: p.sender.tab.id, uuid: m.uuid, request: m.request, contentType: m.contentType });
        }
        catch (exception) {

            console.log('Redwax SignText: background: open native port (attempt two)');

            /*
             * Not able to send the message. (Re)open the port and try
             * once more.
             */
            window.nativePort = browser.runtime.connectNative('eu.redwax.Redwax.SignText');
            window.nativePort.onMessage.addListener(nativeMessaged);
            window.nativePort.onDisconnect.addListener(nativeDisconnected);
            
            /*
             * One more try to send the message.
             */
            try {
                console.log('Redwax SignText: background: send message (attempt two)');
                window.nativePort.postMessage({ url: url, id: p.sender.tab.id, uuid: m.uuid, request: m.request, contentType: m.contentType });
            }
            catch (exception) {

                window.nativePort = undefined;

                /*
                 * No luck, send a message back to the content script with
                 * the bad news.
                 */
                console.log('Redwax SignText: postNativeMessageFailed: ', exception);
                p.postMessage({ uuid: m.uuid, error: 'error:postNativeMessageFailed', exception: exception.message });
                
            }
            
        }
        
    };

    p.onMessage.addListener(messageHandler);

    p.onDisconnect.addListener(function(p) {
        p.onMessage.removeListener(messageHandler);
        console.log('Redwax SignText: tab ' + p.sender.tab.id + ' disconnected.');
        delete csPorts[p.sender.tab.id];
    });
}

browser.runtime.onConnect.addListener(connected);

console.log('Redwax SignText: background ended');
